﻿using System;
using codeContractsBook;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace codeContractsBookTests
{
    [TestClass]
    public class BookTests
    {
        private readonly Book _book = new Book("C#");
        [TestMethod]
        public void ConstructorTest()
        {
            Assert.AreEqual("C#", _book.Title);
            Assert.AreEqual(0.0, _book.Price);
            try
            {
                new Book("C");
                Assert.Fail();
            }
            catch (Exception) { }

            try
            {
                new Book(null);
                Assert.Fail();
            }
            catch (Exception) { }
        }

        [TestMethod]
        public void TitleTest()
        {
            _book.Title = "C# 4.5";
            Assert.AreEqual("C# 4.5", _book.Title);
            try
            {
                _book.Title = "C";
                Assert.Fail();
            }
            catch (Exception) { }
            try
            {
                _book.Title = null;
                Assert.Fail();
            }
            catch (Exception ex)
            {
                Assert.IsTrue(ex.Message.StartsWith("Precondition"));
            }
        }

        [TestMethod]
        public void PriceTest()
        {
            _book.Price = 0.0;
            Assert.AreEqual(0.0, _book.Price);
            try
            {
                _book.Price = -0.1;
                Assert.Fail();
            }
            catch (Exception ex)
            {
                Assert.IsTrue(ex.Message.StartsWith("Precondition"));
            }

        }

        //[TestMethod]
        //[ExpectedException(typeof(Exception))]
        //public void TitleExceptionTest()
        //{
        //    book.Title = null;
        //}

        [TestMethod]
        public void RaisePriceToTest()
        {
            _book.Price = 100;
            _book.RaisePriceTo(101);
            try
            {
                _book.RaisePriceTo(100);
                Assert.Fail();
            }
            catch (Exception)
            {

            }
        }

        [TestMethod]
        public void LowerPriceToTest()
        {
            _book.Price = 100;
            _book.LowerPriceTo(99);
            try
            {
                _book.LowerPriceTo(100);
            }
            catch (ArgumentOutOfRangeException ex)
            {
                Assert.IsTrue(ex.Message.StartsWith("Precondition"));
            }
        }
    }
}
